from fastapi import Depends, Security
from Abstracts.base_composit import BaseComposit

from fwdi.Abstractions.base_controller import BaseController
from fwdi.Abstractions.meta_service import MetaService
from fwdi.Domain.model_user import User
from fwdi.WebApp.web_application import WebApplication
from fwdi.Infrastructure.JwtService.jwt_service import JwtService

class WebService():
    def AddControllers(app:WebApplication)->None:
        app.map_controller(GuestController())

class GuestController(BaseController, metaclass=MetaService):
    def __init__(self, composite:BaseComposit, base_path:str='/'):
        super().__init__(base_path)
        self.__composite:BaseComposit = composite
    
    def get(self, current_user: User = Security(JwtService.get_current_active_user, scopes=["guest"]),):
        result_composit_test = self.__composite.run_once()
        return {
            "Controller": self.__class__.__name__,
            "Method 'GET'": "Hello from KSU Web MVC with Lightweight Dependency Injection",
            "Composite result":result_composit_test,
            "Current user": {
                "Login": current_user.username,
                "Email": current_user.email,
                }
            }
    